#ifndef BIG_DATA_LOADER_H
#define BIG_DATA_LOADER_H

#include <stdio.h>
#include <stdlib.h>
#include <list>
#include <vector>
using namespace std;
#define AVG_WIND_SPEED 0
#define AVG_WIND_DIRECTION 1
#define AVG_AIR_TEMP 2
#define AVG_SOIL_TEMP 3
#define AVG_HUMIDTY 4
#define TOTAL_PRECIPITATION 5

struct DayInFile
{
	FILE* dataFile;
	int month;
	int year;
	int day;
	float avgWindSpeed;
	float avgWindDir;
	float avgAirTemp;
	float avgSoilTemp;	//average 4" soil temp
	float avgHumidity;
	float totalPrecip;
	long fileOffset;	//location of the data for this day in the file dataFile
	DayInFile* next;
};

struct Station
{
	DayInFile*	dailyList;
	float		latitude;
	float		longitude;
	float		utm_easting;
	float		utm_northing;
	int 		elevation;
	
	char* 		stationName;
	char*		stationAbbrv;
	long		numberOfDays;
};

struct WeatherService
{
	vector<Station* > stationListing;
};	

void LoadStations(char* stationsFile, WeatherService*& ws);
void LoadStationDailyWeather(char* dailyWeatherFile, long& numberOfDays, DayInFile*& dailyList);
void DeleteStations(WeatherService*& ws);
//get the dayinfile object for each station for the particular day
DayInFile* GetDayInFileArray(int month, int day, int year,WeatherService* ws,int& returnLength);
void GetNextDate(int& month, int& day, int& year);
double Distance(double x1, double y1, double x2, double y2);
#endif

