#include <pthread.h>
#include <unistd.h>
#include <time.h>
#include <iostream>
using namespace std;

#include "vtkappList.h"
#include "fluidgui.h"

WeatherService *gWeatherService = NULL;
VTKAppList** aList = NULL;

void ExitFunc(void);
void wait(int milliseconds);

int main(int argc, char** argv)
{
	//atexit(ExitFunc);
	
	Illinois::Initialize();
/*	cerr << "Adding app: APP1" << endl;
	VTKAppList::AddApp(0,0,200,200,"APP1");
	wait( 3000 );
	cerr << "Adding app: APP2" << endl;
	VTKAppList::AddApp(200,200,200,200,"APP2");
	

*/	
	//************************************************//

	int size = 0;
	size += sizeof(FILE*);
	size += sizeof(int) * 3;
	size += sizeof(float) * 6;
	size += sizeof(long);
	size += sizeof(DayInFile*);
	
	cerr << "Size of a DayInFile object: " << sizeof(DayInFile) 
	<< " --Double checking: " << size << endl;
//	Load up the weather data!!!!!!
	if(gWeatherService == NULL)
		gWeatherService = new WeatherService();
	char weatherStationsFilename[] = "data/bigdata/location_abbrevs.txt";
	
	char station[100] = "data/bigdata/";
	LoadStations( weatherStationsFilename, gWeatherService );
	
	if(gWeatherService->stationListing.size() <= 0)
	{
		cerr << "didn't load stations!" << endl;
		return 0;
	}
	
	unsigned int ele = 0;
	for( ; ele < gWeatherService->stationListing.size(); ele++)
	{
		Station* s = gWeatherService->stationListing[ele];
	
		memset(station,0,100);
		strcat(station,"data/bigdata/");
		strcat(station, s->stationAbbrv);
		strcat(station,"DAY.txt");
		LoadStationDailyWeather(station , s->numberOfDays, s->dailyList );
	}
	
	//Lets check to see how long it takes to get to the last day
	//of each station!
	clock_t startTime = clock();
	DayInFile* daysArray;
	int length = 0;
	daysArray = GetDayInFileArray(12,31,2003,gWeatherService,length);
	clock_t endTime = clock();
	cerr << "Testing O(n) search time!!!!" << endl;
	cerr << "Time at start: " << startTime << " and ended at: " << endTime
		<< " -- Duration: " << endTime - startTime << endl;
		
	if( daysArray == NULL || length == 0)
	{
		cerr << "Failed to get the array!" << endl;
		DeleteStations(gWeatherService);
		return 0;
	}
	else
	{
	
		for(int cnt = 0; cnt < length; cnt++)
		{
			cerr << "Station: " << 	gWeatherService->stationListing[cnt]->stationName
				<< " has values at date: " 
				<< daysArray[cnt].month << ", "
				<< daysArray[cnt].day << ", "
				<< daysArray[cnt].year << endl;
				
		}
	}

	//Startup AppList Thread
	pthread_t appListThreadID;
	if(aList == NULL)
		aList = new VTKAppList*;
		
	pthread_create( &appListThreadID, NULL, AppListThread, (void*)aList);
	
	//Startup GUI!!!!
	Fl_Double_Window *p = make_main_window();
	p->show();
	cerr << "Calling Fl::run()" << endl;
	Fl::run();
	
	//Clean up!!!
	DeleteStations(gWeatherService);
	//return 0;
	cerr << "Calling Clean Up function" << endl;
	ExitFunc();
	return 0;

}


void ExitFunc(void)
{
	cerr << "Exit function called" << endl;
	(*aList)->Release(true);
	while( !(*aList)->Freed());
	delete (*aList);
	delete aList;
	cerr << "Killed All the Apps" << endl;
}

void wait(int milliseconds)
{
	clock_t endTime = clock() + milliseconds;
	cerr << "waiting";
	while( clock() < endTime );
	cerr << endl <<  "--done waiting" << endl;
}
