#ifndef VTKAPP_LIST_H
#define VTKAPP_LIST_H

#include <pthread.h>
#include "vtkapp.h"
#include <string>
#include <list>
using namespace std;
#include <Fl/Fl.H>
#include <Fl/Fl_Window.H>

struct VTKAppRelayStation
{
	VTKApp** ppApp;
	VTKAppMessageQueue* msgQueueHead;
	VTKAppMessageQueue* msgQueueTail;
};

void* AppListThread(void* );
class VTKAppList
{
public:
	void Initialize(void);
	VTKApp** AddApp(VTKAppProperties* );	//automatically run the app after it's added
/*	void KillApp(VTKApp* aNode); */
	VTKApp* GetApp(string aName);
	VTKApp* GetApp(int index);
	/*static VTKApp* GetAppOnThread(unsigned int threadID);*/
	int GetNumApps(void);
	void KillAllApps(void);
	void Release(bool);
	bool Freed(void);
	bool Release(void);
	VTKAppList();
	~VTKAppList();
	void BeginNewApps(void);
	void RelayMessage(VTKAppMessage* msg, VTKApp** ppApp);
	void TogglePauseAnimations( );
private:
	void WaitForMessageQueueAccess();
	void FreeMessageQueueAccess();
	void WaitForExecuteAppAccess();
	void FreeExecuteAppAccess();
	
	friend void* AppListThread(void*);
	//list<VTKApp** > listing;
	list<VTKAppRelayStation* > listing;
	bool release;
	bool freed;
	bool executeAppQueue;
	bool accessingMessageQueue;
	pthread_mutex_t	messageMutex;
	list<VTKAppProperties* > executeQueue;
	bool NoAppRequested;
	bool PauseAnims;
	
	
};



#endif
